# -*- coding: utf-8 -*-
# @Author: wangkun
# @Time: 2023/4/23
import argparse
import os
import sys
import time
sys.path.append(os.getcwd())
from common.public import task_fun
from common.common import Common
from gongzhonghao.gongzhonghao_author.gongzhonghao3_author import GongzhonghaoAuthor3


def main(log_type, crawler, task, env):
    # while True:
    #     cmd = 'ps -ef | grep "run_gongzhonghao3_author_scheduling.py" | grep -v "grep"'
    #     result = os.popen(cmd).read()
    #     if len(result) > 573:
    #         Common.logger(log_type, crawler).info("公众号_3抓取未完成，无需启动新进程")
    #         time.sleep(1)
    #     else:
    #         break
    task_dict = task_fun(task)['task_dict']
    rule_dict = task_fun(task)['rule_dict']
    Common.logger(log_type, crawler).info(f"调度任务:{task_dict}")
    Common.logger(log_type, crawler).info(f"抓取规则:{rule_dict}\n")
    Common.logger(log_type, crawler).info(f'开始抓取 {task_dict["task_name"]} 定向榜\n')
    GongzhonghaoAuthor3.get_all_videos(log_type=log_type,
                                       crawler=crawler,
                                       rule_dict=rule_dict,
                                       env=env)
    Common.del_logs(log_type, crawler)
    Common.logger(log_type, crawler).info('抓取完一轮\n')


if __name__ == "__main__":
    parser = argparse.ArgumentParser()  ## 新建参数解释器对象
    parser.add_argument('--log_type', type=str)  ## 添加参数,注明参数类型
    parser.add_argument('--crawler')  ## 添加参数
    parser.add_argument('--task')  ## 添加参数
    parser.add_argument('--env')  ## 添加参数
    args = parser.parse_args()  ### 参数赋值，也可以通过终端赋值
    main(log_type=args.log_type,
         crawler=args.crawler,
         task=args.task,
         env=args.env)